;==============================================================================
;       Test Department's WINDOWS 32 BIT x86 ASSEMBLY example's        027
;==============================================================================

;==============================================================================
; ==> Part 027 : Cool control (ReBar control)
;------------------------------------------------------------------------------
; ey cool ey,
; cool control is a powerfull control and I'm sure you will enjoy.
; Today I'm very unkind (laughing), so only the basic stuff is shown.
; You can add as much controls and bands you like to a cool control.
; Background bitmaps are simple textures, cool control seems to autostretch them.
; 
; Of course there is also some trouble waiting for us ...
; For me cool control type do not work with ComboBox, you must use ComboBoxEx32.
; If you wonna be supercool assign a Toolbar / Toolbar frame to the cool control.
; You must use the common control styles 'CCS_NOPARENTALIGN' and 'CCS_NORESIZE'
; on API 'CreateToolbarEx' !
;
;
; Will be continued ...
; 
; The API 'InitCommonControls' is obsolete,so use API 'InitCommonControlsEx'.
; The recommend help file for all control example is shellcc.chm/shellcc.chi.
;
; 
;
; cool TD                    td@crahkob.com
;

;==============================================================================
; Assembler directives
;------------------------------------------------------------------------------
.386                    ; the processor our program want run on
.Model Flat ,StdCall    ; always the same for Win9x (32 Bit)
option casemap:none     ; case sensitive !!!

;==============================================================================
; Include all files where API functins resist you want use, set correct path
;------------------------------------------------------------------------------
include D:\Masm32\include\windows.inc
includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib
includelib comctl32.lib

;==============================================================================
; Declaration of used API functions,take a look into WIN32.HLP and *.inc files
;------------------------------------------------------------------------------
GetModuleHandleA        PROTO :DWORD
InitCommonControlsEx    PROTO :DWORD
LoadIconA               PROTO :DWORD,:DWORD
LoadCursorA             PROTO :DWORD,:DWORD
RegisterClassExA        PROTO :DWORD
CreateSolidBrush        PROTO :DWORD
CreateWindowExA         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ShowWindow              PROTO :DWORD,:DWORD
UpdateWindow            PROTO :DWORD
GetMessageA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
TranslateMessage        PROTO :DWORD
DispatchMessageA        PROTO :DWORD
PostQuitMessage         PROTO :DWORD
DefWindowProcA          PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess             PROTO :DWORD
DestroyWindow           PROTO :DWORD
EnableWindow            PROTO :DWORD,:DWORD
InvalidateRect          PROTO :DWORD,:DWORD,:DWORD
SendMessageA            PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreateToolbarEx         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
LoadBitmapA             PROTO :DWORD,:DWORD
DeleteObject            PROTO :DWORD

;==============================================================================
; .const = the constants area starts here,constants are defined and fixed
;------------------------------------------------------------------------------
.const 
; - Parameter MAIN WINDOW CallBack Procedure ( API=RegisterClassExA ) -
WP1_CallBack            equ [ebp+4]     ;return address
WP1_hWnd                equ [ebp+8]     ;handle of window who receives message
WP1_uMsg                equ [ebp+12]    ;the message number
WP1_wParam              equ [ebp+16]    ;extra info about the message
WP1_lParam              equ [ebp+20]    ;extra info about the message

;==============================================================================
; .Data = the data area starts here, datas are defined but not fixed
;------------------------------------------------------------------------------
.Data
ClassName               db "TDCool",0                   ;name windows class
WindowName              db "Cool control example - Done by Test Department - http://www.crahkob.com/td",0
RebarClassName          db "ReBarWindow32",0            ;predefined class
ComboboxClassName       db "ComboBoxEx32",0             ;predefined class
ToolbarClassName        db "ToolbarWindow32",0          ;predefined class
ButtonClassName         db "BUTTON",0                   ;predefined class
sz00                    db "ComboBox",0                 ;string
sz01                    db "Toolbar",0                  ;
sz02                    db "Button",0                   ;
sz10                    db "ComboBoxEx32 Text 0",0      ;
sz11                    db "ComboBoxEx32 Text 1",0      ;
sz12                    db "ComboBoxEx32 Text 2",0      ;

align 4
Xpos_org                dd 0C0h         ;X orgin point window
Ypos_org                dd 120h         ;Y orgin point window
Xpos_max                dd 240h         ;max. window width
Ypos_max                dd 0C0h         ;max. window height

align 4
; - WndClassEx Structure -
cbSize                  dd 0h           ;size in bytes of this structure
style                   dd 0h           ;window style
lpfnWndProc             dd 0h           ;address of user proc function
cbclsExtra              dd 0h           ;extra bytes to allocate set to 0
cbWndExtra              dd 0h           ;extra bytes class directive, rc file
hInstance               dd 0h           ;program handle(API=GetModuleHandleA)
hIcon                   dd 0h           ;handle of icon (API=LoadIconA)
hcursor                 dd 0h           ;handle of cursor (API=LoadCursor)
hbrBackground           dd 0h           ;background color, 0=transparent
lpszMenuName            dd 0h           ;name of menu class in resource file
lpszClassName           dd 0h           ;name of windows this window class
hIconSm                 dd 0h           ;iconhandle 0=search in resource file

; - Msg Structure -
hWnd                    dd 0h           ;handle of window who receives message
message                 dd 0h           ;the message number
wParam                  dd 0h           ;extra info about the message
lParam                  dd 0h           ;extra info about the message 
time                    dd 0h           ;time the message was posted 
xpt                     dd 0h           ;cursor x-position, POINT struc
ypt                     dd 0h           ;cursor x-position, POINT struc

; - TBBUTTON structure ( API=CreateToolbarEx ) - ARRAY !!!
iBitmap_00              dd 0h           ;zero-based index of button image
idCommand_00            dd 0C0h         ;ID or, if fsStyle=TBSTYLE_SEP, zero
fsState_00              db 4h           ;state flags,4h=TBSTATE_ENABLED
fsStyle_00              db 0h           ;button style,0h=TBSTYLE_BUTTON
bReserved_00            db 2h dup (0)   ;reserved byte
dwData_00               dd 0h           ;application-defined value
iString_00              dd 0h           ;zero-based index of button string

iBitmap_01              dd 1h           ;zero-based index of button image
idCommand_01            dd 0C1h         ;ID of button, WM_COMMAND uMsg/wParam
fsState_01              db 4h           ;state flags,4h=TBSTATE_ENABLED
fsStyle_01              db 0h           ;button style,0h=TBSTYLE_BUTTON
bReserved_01            db 2h dup (0)   ;reserved byte
dwData_01               dd 0h           ;application-defined value
iString_01              dd 0h           ;zero-based index of button string

iBitmap_02              dd 2h
idCommand_02            dd 0C2h
fsState_02              db 4h
fsStyle_02              db 0h
bReserved_02            db 2h dup (0)
dwData_02               dd 0h
iString_02              dd 0h

iBitmap_03              dd 3h
idCommand_03            dd 0C3h
fsState_03              db 4h
fsStyle_03              db 0h
bReserved_03            db 2h dup (0)
dwData_03               dd 0h
iString_03              dd 0h

;==============================================================================
; .Data? = the data? area starts here, not defined and not fixed
;------------------------------------------------------------------------------
.data?
align 4
hWnd_rebar              dd ?            ;handle ipaddress control window
hWnd_toolbar            dd ?            ;handle toolbar
hWnd_combobox           dd ?            ;handle combobox
hWnd_button             dd ?            ;handle button

hImg_rebarband0         dd ?            ;handle rebarband bitmap
hImg_rebarband1         dd ?            ;handle rebarband bitmap
hImg_rebarband2         dd ?            ;handle rebarband bitmap

; - INITCOMMONCONTROLSEX structure -
ICC_dwSize              dd ?            ;size of the structure, in bytes
ICC_dwICC               dd ?            ;set of bit flags that indicate which
                                        ;common control classes will be loaded

; - REBARINFO structure -
RBI_cbSize              dd ?            ;size of the structure, in bytes
RBI_fMask               dd ?            ;flag, characteristics of rebar control
RBI_himl                dd ?            ;handle to an image list

; - REBARBANDINFO structure -
RBBIM_cbSize            dd ?            ;size of the structure, in bytes
RBBIM_fMask             dd ?            ;flags which members are valid or must filled
RBBIM_fStyle            dd ?            ;flags that specify the band style
RBBIM_clrFore           dd ?            ;band foreground color
RBBIM_clrBack           dd ?            ;band background color
RBBIM_lpText            dd ?            ;pointer to buffer, display text for the band
RBBIM_cch               dd ?            ;size of the buffer at RBBIM_lpText, in bytes
RBBIM_iImage            dd ?            ;index of image that should displayed in band
RBBIM_hwndChild         dd ?            ;handle child window contained in the band
RBBIM_cxMinChild        dd ?            ;minimum width of the child window, in pixels
RBBIM_cyMinChild        dd ?            ;minimum height of the child window, in pixels
RBBIM_cx                dd ?            ;length of the band, in pixels
RBBIM_hbmBack           dd ?            ;handle bitmap, the background for this band
RBBIM_wID               dd ?            ;identifier for custom draw notification msg.
RBBIM_cyChild           dd ?            ;initial height of the band, in pixels
RBBIM_cyMaxChild        dd ?            ;maximum height of the band, in pixels
RBBIM_cyIntegral        dd ?            ;step value by which the band can grow/shrink
RBBIM_cxIdeal           dd ?            ;ideal width of the band, in pixels
RBBIM_lParam            dd ?            ;32-bit application-defined value
RBBIM_cxHeader          dd ?            ;size of the band's header, in pixels

; - COMBOBOXEXITEM structure -
CBEI_mask               dd ?            ;flags, valid or must be filled
CBEI_iItem              dd ?            ;zero-based index of the item
CBEI_pszText            dd ?            ;char buffer contains or receives item's text
CBEI_cchTextMax         dd ?            ;length of pszText, in characters
CBEI_iImage             dd ?            ;zero-based index image within the image list
CBEI_iSelectedImage     dd ?            ;zero-based index image within the image list
CBEI_iOverlay           dd ?            ;one-based index overlay image within image list
CBEI_iIndent            dd ?            ;number of indent spaces to display for the item
CBEI_lParam             dd ?            ;32-bit value specific to the item

;==============================================================================
; .CODE = our code area starts here     Main=label of our program code
;------------------------------------------------------------------------------
.Code
Main:

;==============================================================================
; Always get your program ID first (API=GetModuleHandleA)
;------------------------------------------------------------------------------
push    0h                      ;lpModuleHandle, 0=get program handle
call    GetModuleHandleA        ;- API Function -
mov     hInstance,eax           ;return value in eax=handle of program

;==============================================================================
; Rebar (cool bar) control seems to be part of common controls, force to init.
;------------------------------------------------------------------------------
mov     ICC_dwSize,8h           ;size of the structure
mov     ICC_dwICC,0h            ;
or      ICC_dwICC,0400h         ;set ICC_COOL_CLASSES bit flag, cool control
or      ICC_dwICC,0200h         ;set ICC_USEREX_CLASSES bit flag, combobox
or      ICC_dwICC,0004h         ;set ICC_BAR_CLASSES bit flag, bar control
push    OFFSET ICC_dwSize       ;pointer to INITCOMMONCONTROLSEX structure
call    InitCommonControlsEx    ;- API Function -

;==============================================================================
; The API function "RegisterClassExA" registers a window class
; This API needs a "WNDCLASSEX" structure so we fill it with correct values
;------------------------------------------------------------------------------
mov     cbSize,30h              ;size in bytes of WNDCLASSEX structure
mov     style,3h                ;style, CS_HREDRAW, CS_VREDRAW
mov     lpfnWndProc,OFFSET WP1  ;address of user lpfnWndProc function
mov     cbclsExtra,0h           ;extra bytes to allocate set to 0
mov     cbWndExtra,0h           ;class directive in rc file
;------------------------------------------------------------------------------
; API "CreateSolidBrush" creates a logical brush with the specified solid color
;------------------------------------------------------------------------------
push    00000000h                       ;crColor, brush color value RGB
call    CreateSolidBrush                ;- API Function -
mov     hbrBackground,eax               ;handle brush, background color
mov     lpszMenuName,0h                 ;menu name in resource file
mov     lpszClassName,OFFSET ClassName  ;name of windows class
;------------------------------------------------------------------------------
; API "LoadIconA" loads an icon defined in the resource file and store the
; handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    1000                    ;icon-string or icon resource id
push    hInstance               ;our program handle
call    LoadIconA               ;- API Function -
mov     hIcon,eax               ;handle of newly loaded icon
mov     hIconSm,eax             ;iconhandle 0=search in rc file
;------------------------------------------------------------------------------
; API "LoadCursorA" loads a default system cursor, in this case we must set
; hInstance to 0 and lpCursorName to a default system cursor value, here 32512
; Then we store the cursor handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    32512                   ;lpCursorName, default value in dezimal
push    0h                      ;hInstance, 0=default system cursor
call    LoadCursorA             ;- API Function -
mov     hcursor,eax             ;store handle of the cursor
;------------------------------------------------------------------------------
; Now, after filled the "WNDCLASSEX" structure we call API "RegisterClassEx"
;------------------------------------------------------------------------------
push    OFFSET cbSize           ;pointer to WNDCLASSEX structure
call    RegisterClassExA        ;- API Function -

;==============================================================================
; API "CreateWindowExA" creates an overlapped, pop-up, or child window with an
; extended style. The return value in EAX is the handle of the new window.
; This API sends a WM_CREATE message to the window procedure (WP1).
;------------------------------------------------------------------------------
push    0h                  ;lpParam, extra pointer data 0=no data
push    hInstance           ;hInstance, handle of our program
push    0h                  ;hMenu, handle window menu 0=class menu
push    0h                  ;hWndParent, handle parent window 0=no
push    Ypos_max            ;intnHeight, window height pixel
push    Xpos_max            ;intnWidth, window width pixel
push    Ypos_org            ;inty, vertical position window
push    Xpos_org            ;intx, horizontal position window
push    02CA0000h           ;dwStyle, look into WIN32.HLP and window.inc
push    OFFSET WindowName   ;lpWindowName, pointer to window name
push    OFFSET ClassName    ;lpClassName, pointer to class name
push    0h                  ;dwExStyle, extra window style 0=no
call    CreateWindowExA     ;- API Function -
mov     hWnd,eax            ;hwnd, return value=handle of window

;==============================================================================
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    1h                  ;nCmdShow, show state 1=SW_SHOWNORMAL
push    hWnd                ;hwnd, handle of window
call    ShowWindow          ;- API Function -

;==============================================================================
; API "UpdateWindow" updates the area of the specified window by sending a
; WM_PAINT message to the window if the window's update region is not empty.
;------------------------------------------------------------------------------
push    hWnd                ;hwnd, handle of window
call    UpdateWindow        ;- API Function -

;==============================================================================
; API "GetMessageA" retrieves a message & places it in the specified structure.
;------------------------------------------------------------------------------
LoopGetMessage:
push    0h                  ;wMsgFilterMax, highest message value
push    0h                  ;wMsgFilterMin, lowest message value
push    0h                  ;hWnd, handle of window who gets msg.
push    OFFSET hWnd         ;lpMsg, pointer to MSG structure
call    GetMessageA         ;- API Function -
cmp     eax,0h              ;check if return value=0 (exit)
je      ExitPrg             ;if return value is 0 goto LABEL

;==============================================================================
; API "TranslateMessage" translates key code into ASCII character messages
;------------------------------------------------------------------------------
push    OFFSET hWnd         ;lpMSG, pointer to msg structure
call    TranslateMessage    ;- API Function - keyboard code

;==============================================================================
; API "DispatchMessageA" function dispatches a message to a window procedure.
;------------------------------------------------------------------------------
push    OFFSET hWnd         ;lpMSG, pointer to msg structure
call    DispatchMessageA    ;- API Function -
jmp     LoopGetMessage      ;check for message again, goto LABEL

ExitPrg:
;==============================================================================
; Next we terminate our program (API=ExitProcess)
;------------------------------------------------------------------------------
push    hInstance           ;push our programm handle to exit
call    ExitProcess         ;- API Function -

;##############################################################################
; The Window Procedure lpfnWndProc (API=RegisterClassExA) for this window.
;------------------------------------------------------------------------------
WP1:
push    ebp                     ;create stack frame
mov     ebp,esp                 ;
pushad                          ;push all register to the stack

mov     eax,WP1_uMsg            ;move the message number to eax
;==============================================================================
; WM_CREATE (value=01h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_01h:
cmp     eax,1h                  ;check if WM_CREATE message recieved
jne     WP1_uMsg_02h            ;if not goto label
call    My_Rebar                ;- SubRoutine -
call    My_RebarBand_Toolbar    ;- SubRoutine -
call    My_RebarBand_Combobox   ;- SubRoutine -
call    My_RebarBand_Button     ;- SubRoutine -
jmp     WP1_return

;==============================================================================
; WM_DESTROY (value=02h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_02h:
cmp     eax,2h                  ;check if value=2h (WM_DESTROY)
jne     WP1_uMsg_0Fh            ;if not 2h go to LABEL
xyz:
call    My_CleanSystem          ;- SubRoutine -
;------------------------------------------------------------------------------
; API "PostQuitMessage" indicates to Windows a request to terminate
;------------------------------------------------------------------------------
push    0h                      ;nExitCode, exit code=wParam
call    PostQuitMessage         ;- API Function -
popad                           ;pop all register back from stack
xor     eax,eax                 ;set eax to 0 to exit our program
mov     esp,ebp                 ;delete stack frame
pop     ebp                     ;
ret     10h                     ;return and clear stack

;==============================================================================
; WM_PAINT (value=0Fh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_0Fh:
cmp     eax,0Fh                 ;check if WM_PAINT message recieved
jne     WP1_uMsg_4Eh            ;if not goto label

jmp     WP1_return

;==============================================================================
; WM_NOTIFY (value=4Eh) message, gives us a pointer to a NMHDR structure.
;------------------------------------------------------------------------------
WP1_uMsg_4Eh:
cmp     eax,4Eh                 ;check if WM_NOTIFY message recieved
jne     WP1_uMsg_7Eh            ;if not goto label
mov     ebx,WP1_lParam          ;pointer to structure, given by windows !
;------------------------------------------------------------------------------
; The NMHDR structure contains information about a notification message.
; The POINTER to this structure is specified as lParam member of WM_NOTIFY.
; This POINTER is given to us with the WM_NOTIFY message by Windows.
; - NMHDR structure -
; hwndFrom      = [WP1_lParam+00]   ;handle to control sending message 
; idFrom        = [WP1_lParam+04]   ;identifier of control sending message
; code          = [WP1_lParam+08]   ;notification code
; 
; !!! THERE ARE SEVERAL COOL NOTIFICATION MESSAGES AND STRUCTURES AVAIBLE !!!
; !!!!    Please take a look into the microsoft help file shellcc.chm     !!!!
; 
;------------------------------------------------------------------------------
mov     eax,[ebx+0]             ;get the handle of the control sending msg.
cmp     eax,hWnd_rebar          ;is control = cool control ?
jne     WP1_return

jmp     WP1_return

;==============================================================================
; WM_DISPLAYCHANGE (value=7Eh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_7Eh:
cmp     eax,7Eh                 ;check if WM_DISPLAYCHANGE message recieved
jne     WP1_uMsg_111h           ;if not goto label
;------------------------------------------------------------------------------
; API "InvalidateRect" adds a rectangle to specified window's update region.
; This function performs a WM_PAINT message.
;------------------------------------------------------------------------------
push    0h                      ;bErase, erase-background flag
push    0h                      ;lpRect, rect structure, 0h=client area
push    WP1_hWnd                ;hWnd, handle window update region
call    InvalidateRect          ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_COMMAND (value=111h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_111h:
cmp     eax,111h                ;check if WM_COMMAND message recieved
jne     WP1_uMsg_112h           ;if not goto label
mov     eax,WP1_wParam          ;extra info about the message in ax

jmp     WP1_return

;==============================================================================
; WM_SYSCOMMAND (value=112h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_112h:
cmp     eax,112h                ;check if WM_COMMAND message recieved
jne     WP1_return              ;if not goto label
mov     eax,WP1_wParam          ;extra info about the message
cmp     eax,0F060h              ;SC_CLOSE=0F060h received ?
jne     WP1_return              ;
call    My_CleanSystem          ;- SubRoutine -
jmp     WP1_return

;==============================================================================
; API "DefWindowProcA" calls the window procedure to provide default processing
; for any window messages that an application does not process.
; This function ensures that every message is processed.
; It is called with the same parameters received by the window procedure.
;------------------------------------------------------------------------------
WP1_return:
popad                           ;pop all register from stack
push    WP1_lParam              ;extra info about the message
push    WP1_wParam              ;extra info about the message
push    WP1_uMsg                ;the message number
push    WP1_hWnd                ;handle of window who receives message
call    DefWindowProcA          ;- API Function -
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack

;==============================================================================
; Leaving the window procedure returning TRUE (1) or FALSE (0) in EAX.
;------------------------------------------------------------------------------
WP1_return_0:
popad                           ;pop all register from stack
mov     eax,0h                  ;set EAX to FALSE (0)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
WP1_return_1:
popad                           ;pop all register from stack
mov     eax,1h                  ;set EAX to TRUE (1)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
;##############################################################################

;******************************************************************************
; My own subroutine(s) for a compacter code resist here ...
;------------------------------------------------------------------------------
My_Rebar:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (ReBar)
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    100h                    ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
push    0h                      ;inty, vertical position window
push    0h                      ;intx, horizontal position window
push    56803640h               ;dwStyle, RBS_DBLCLKTOGGLE      = 8000h
                                ;         RBS_VERTICALGRIPPER   = 4000h
                                ;         RBS_AUTOSIZE          = 2000h
                                ;         RBS_REGISTERDROP      = 1000h
                                ;         RBS_FIXEDORDER        = 0800h
                                ;         RBS_BANDBORDERS       = 0400h
                                ;         RBS_VARHEIGHT         = 0200h
                                ;         RBS_TOOLTIPS          = 0100h
                                ;         CCS_NODIVIDER         =  040h
                                ;         CCS_NOPARENTALIGN     =   08h
                                ;         CCS_NORESIZE          =   04h
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET RebarClassName   ;lpClassName, pointer to class name
push    80h                     ;dwExStyle, WS_EX_TOOLWINDOW=80h
call    CreateWindowExA         ;- API Function -
mov     hWnd_rebar,eax          ;hwnd, store handle of window
mov     RBI_cbSize,0Ch          ;size of REBARINFO structure
mov     RBI_fMask,0h            ;
mov     RBI_himl,0h             ;
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    OFFSET RBI_cbSize       ;lParam, pointer to REBARINFO structure 
push    0h                      ;wParam, set to 0
push    1028                    ;uMsg, RB_SETBARINFO (WM_USER=1024)+4
push    hWnd_rebar              ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
ret

My_RebarBand_Toolbar:
;------------------------------------------------------------------------------
; API "CreateToolbarExA" creates a child window ( TOOLBAR ). 
; Parameter "ws" defines the child windows style; it also enables tooltiptext.
;------------------------------------------------------------------------------
push    14h                     ;uStructSize,size TBBUTTON structure
push    14h                     ;dyBitmap,height pixels of the images
push    14h                     ;dxBitmap,width pixels of the images
push    0h                      ;dyButton,height pixels of the buttons
push    0h                      ;dxButton,width pixels of the buttons
push    4h                      ;iNumButtons,Number buttons in toolbar
push    OFFSET iBitmap_00       ;lpButtons,pointer TBBUTTON structure
push    1100                    ;wBMID,ID for the bitmap resource
push    hInstance               ;hBMInst,instance bitmap resource
push    4h                      ;nBitmaps, # of button images in file
push    120h                    ;wID,control identifier for toolbar
push    5400880Ch               ;ws, TBSTYLE_TRANSPARENT= 8000h
                                ;    TBSTYLE_FLAT       =  800h
                                ;    TBSTYLE_WRAPABLE   =  200h
                                ;    CCS_ADJUSTABLE     =   20h
                                ;    TBSTYLE_AUTOSIZE   =   10h
                                ;    CCS_NOPARENTALIGN  =   08h
                                ;    CCS_NORESIZE       =   04h
push    hWnd_rebar              ;hwnd,handle owner window 0=no owner
call    CreateToolbarEx         ;- API Function -
mov     hWnd_toolbar,eax        ;handle of toolbar child window
mov     ebx,eax                 ;save handle for future use
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message, TB_AUTOSIZE to fit toolbar and bitmaps
;------------------------------------------------------------------------------
push    0h                      ;lParam, second message parameter
push    0h                      ;wParam, first message parameter (ID)
push    421h                    ;uMsg, send TB_AUTOSIZE message
push    hWnd_toolbar            ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
push    2000                    ;lpBitmapName, bitmap resource ID
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     hImg_rebarband1,eax     ;hObject, handle of graphic object
;------------------------------------------------------------------------------
; Fill necassary members of REBARBANDINFO structure
;------------------------------------------------------------------------------
mov     RBBIM_cbSize,50h        ;size of REBARBANDINFO structure
mov     RBBIM_fMask,0B7h        ;flags which members are valid or must filled
                                ;RBBIM_STYLE        = 0001h
                                ;RBBIM_COLORS       = 0002h
                                ;RBBIM_TEXT         = 0004h
                                ;RBBIM_IMAGE        = 0008h
                                ;RBBIM_CHILD        = 0010h
                                ;RBBIM_CHILDSIZE    = 0020h
                                ;RBBIM_SIZE         = 0040h
                                ;RBBIM_BACKGROUND   = 0080h
                                ;RBBIM_ID           = 0100h
                                ;RBBIM_IDEALSIZE    = 0200h
                                ;RBBIM_LPARAM       = 0400h
                                ;RBBIM_HEADERSIZE   = 0800h
mov     RBBIM_fStyle,0C4h       ;flags that specify the band style
                                ;RBBS_BREAK         = 0001h
                                ;RBBS_FIXEDSIZE     = 0002h
                                ;RBBS_CHILDEDGE     = 0004h
                                ;RBBS_HIDDEN        = 0008h
                                ;RBBS_NOVERT        = 0010h
                                ;RBBS_FIXEDBMP      = 0020h
                                ;RBBS_VARIABLEHEIGHT= 0040h
                                ;RBBS_GRIPPERALWAYS = 0080h
mov     RBBIM_clrFore,00008000h ;band foreground color
mov     RBBIM_clrBack,00000000h ;band background color
mov     RBBIM_lpText,OFFSET sz01;pointer to buffer, display text for the band
mov     RBBIM_cch,0h            ;buffersize RBBIM_lpText in bytes, not used !
mov     RBBIM_iImage,0h         ;index image displayed in band, not used !
mov     RBBIM_hwndChild,ebx     ;handle child window contained in the band
mov     RBBIM_cxMinChild,70h    ;minimum width of the child window, in pixels
mov     RBBIM_cyMinChild,1Ch    ;minimum height of the child window, in pixels
mov     RBBIM_cx,70h            ;length of the band, in pixels
mov     RBBIM_hbmBack,eax       ;handle bitmap, the background for this band
mov     RBBIM_wID,0h            ;id for custom draw notification msg., not used !
mov     RBBIM_cyChild,1Ch       ;initial height of the band, in pixels
mov     RBBIM_cyMaxChild,1Ch    ;maximum height of the band, in pixels
mov     RBBIM_cyIntegral,1h     ;step value by which band can grow/shrink, not used !
mov     RBBIM_cxIdeal,70h       ;ideal width of the band, in pixels, not used !
mov     RBBIM_lParam,0h         ;32-bit application-defined value, not used !
mov     RBBIM_cxHeader,0h       ;size of the band's header, in pixels, not used !
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    OFFSET RBBIM_cbSize     ;lParam, pointer to REBARBANDINFO structure 
push    -1                      ;wParam, index location where band will inserted
push    1025                    ;uMsg, RB_INSERTBAND (WM_USER=1024)+1
push    hWnd_rebar              ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    5h                      ;nCmdShow, show state 5h=SW_SHOW
push    hWnd_toolbar            ;hwnd, handle of window
call    ShowWindow              ;- API Function -
ret

My_RebarBand_Combobox:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (COMBOBOX)
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    110h                    ;hMenu, the child-window ID
push    hWnd_rebar              ;hWndParent, handle parent window 0=no
push    3Ch                     ;intnHeight, window height pixel, 3 lines
push    40h                     ;intnWidth, window width pixel
push    0h                      ;inty, vertical position window
push    0h                      ;intx, horizontal position window
push    54200003h               ;dwStyle, WS_VSCROLL=200000, CBS_DROPDOWNLIST=3h
push    OFFSET sz10             ;lpWindowName, pointer to window name
push    OFFSET ComboboxClassName;lpClassName, pointer to class name
push    0h                      ;dwExStyle, 
call    CreateWindowExA         ;- API Function -
mov     hWnd_combobox,eax       ;hwnd, store handle of window
mov     ebx,eax                 ;save handle for future use
;------------------------------------------------------------------------------
; Fill necessary members of the COMBOBOXEXITEM structure
;------------------------------------------------------------------------------
mov     CBEI_mask,1h            ;flags, valid or must be filled, CBEIF_TEXT=1h
mov     CBEI_iItem,-1           ;zero-based index of the item
mov     CBEI_pszText,OFFSET sz10;char buffer contains or receives item's text
mov     CBEI_cchTextMax,0h      ;length of pszText, in characters, not used !
mov     CBEI_iImage,0h          ;0-based index img within the img list, not used !
mov     CBEI_iSelectedImage,0h  ;0-based index img within the img list, not used !
mov     CBEI_iOverlay,0h        ;1-based index overlay img within img list, not used !
mov     CBEI_iIndent,0h         ;number indent spaces to display for item, not used !
mov     CBEI_lParam,0h          ;32-bit value specific to the item, not used !
;------------------------------------------------------------------------------
; API "SendMessageA" sends a CBEM_INSERTITEM to the combo box
;------------------------------------------------------------------------------
push    OFFSET CBEI_mask        ;lParam, lpsz, address of string to insert
push    0h                      ;wParam,
push    401h                    ;uMsg, CBEM_INSERTITEM, (WM_USER=0400h)+1
push    hWnd_combobox           ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
mov     CBEI_pszText,OFFSET sz11;char buffer contains or receives item's text
;------------------------------------------------------------------------------
; API "SendMessageA" sends a CBEM_INSERTITEM to the combo box
;------------------------------------------------------------------------------
push    OFFSET CBEI_mask        ;lParam, lpsz, address of string to insert
push    0h                      ;wParam,
push    401h                    ;uMsg, CBEM_INSERTITEM, (WM_USER=0400h)+1
push    hWnd_combobox           ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
mov     CBEI_pszText,OFFSET sz12;char buffer contains or receives item's text
;------------------------------------------------------------------------------
; API "SendMessageA" sends a CBEM_INSERTITEM to the combo box
;------------------------------------------------------------------------------
push    OFFSET CBEI_mask        ;lParam, lpsz, address of string to insert
push    0h                      ;wParam,
push    401h                    ;uMsg, CBEM_INSERTITEM, (WM_USER=0400h)+1
push    hWnd_combobox           ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessageA" sends a CB_SETCURSEL to the combo box
;------------------------------------------------------------------------------
push    0h                      ;lParam, not used must be zero
push    0h                      ;wParam, index, item index
push    14Eh                    ;uMsg, CB_SETCURSEL
push    hWnd_combobox           ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
push    2010                    ;lpBitmapName, bitmap resource ID
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     hImg_rebarband0,eax     ;hObject, handle of graphic object
;------------------------------------------------------------------------------
; Fill necassary members of REBARBANDINFO structure
;------------------------------------------------------------------------------
mov     RBBIM_cbSize,50h        ;size of REBARBANDINFO structure
mov     RBBIM_fMask,0B7h        ;flags which members are valid or must filled
                                ;RBBIM_STYLE        = 0001h
                                ;RBBIM_COLORS       = 0002h
                                ;RBBIM_TEXT         = 0004h
                                ;RBBIM_IMAGE        = 0008h
                                ;RBBIM_CHILD        = 0010h
                                ;RBBIM_CHILDSIZE    = 0020h
                                ;RBBIM_SIZE         = 0040h
                                ;RBBIM_BACKGROUND   = 0080h
                                ;RBBIM_ID           = 0100h
                                ;RBBIM_IDEALSIZE    = 0200h
                                ;RBBIM_LPARAM       = 0400h
                                ;RBBIM_HEADERSIZE   = 0800h
mov     RBBIM_fStyle,0C4h       ;flags that specify the band style
                                ;RBBS_BREAK         = 0001h
                                ;RBBS_FIXEDSIZE     = 0002h
                                ;RBBS_CHILDEDGE     = 0004h
                                ;RBBS_HIDDEN        = 0008h
                                ;RBBS_NOVERT        = 0010h
                                ;RBBS_FIXEDBMP      = 0020h
                                ;RBBS_VARIABLEHEIGHT= 0040h
                                ;RBBS_GRIPPERALWAYS = 0080h
mov     RBBIM_clrFore,00FF0000h ;band foreground color
mov     RBBIM_clrBack,00000000h ;band background color
mov     RBBIM_lpText,OFFSET sz00;pointer to buffer, display text for the band
mov     RBBIM_cch,0h            ;buffersize RBBIM_lpText in bytes, not used !
mov     RBBIM_iImage,0h         ;index image displayed in band, not used !
mov     RBBIM_hwndChild,ebx     ;handle child window contained in the band
mov     RBBIM_cxMinChild,90h    ;minimum width of the child window, in pixels
mov     RBBIM_cyMinChild,14h    ;minimum height of the child window, in pixels
mov     RBBIM_cx,080            ;length of the band, in pixels
mov     RBBIM_hbmBack,eax       ;handle bitmap, the background for this band
mov     RBBIM_wID,0h            ;id for custom draw notification msg., not used !
mov     RBBIM_cyChild,18h       ;initial height of the band, in pixels
mov     RBBIM_cyMaxChild,18h    ;maximum height of the band, in pixels
mov     RBBIM_cyIntegral,1h     ;step value by which band can grow/shrink, not used !
mov     RBBIM_cxIdeal,90h       ;ideal width of the band, in pixels, not used !
mov     RBBIM_lParam,0h         ;32-bit application-defined value, not used !
mov     RBBIM_cxHeader,0h       ;size of the band's header, in pixels, not used !
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    OFFSET RBBIM_cbSize     ;lParam, pointer to REBARBANDINFO structure 
push    -1                      ;wParam, index location where band will inserted
push    1025                    ;uMsg, RB_INSERTBAND (WM_USER=1024)+1
push    hWnd_rebar              ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
ret

My_RebarBand_Button:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (BUTTON)
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    130h                    ;hMenu, the child-window ID
push    hWnd_rebar              ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
push    0h                      ;inty, vertical position window
push    0h                      ;intx, horizontal position window
push    54000000h               ;dwStyle,
push    OFFSET sz02             ;lpWindowName, pointer to window name
push    OFFSET ButtonClassName  ;lpClassName, pointer to class name
push    0300h                   ;dwExStyle, 
call    CreateWindowExA         ;- API Function -
mov     hWnd_button,eax         ;hwnd, store handle of window
mov     ebx,eax                 ;save handle for future use
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
push    2020                    ;lpBitmapName, bitmap resource ID
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     hImg_rebarband2,eax     ;hObject, handle of graphic object
mov     ecx,eax                 ;save handle for future use
;------------------------------------------------------------------------------
; Fill necassary members of REBARBANDINFO structure
;------------------------------------------------------------------------------
mov     RBBIM_cbSize,50h        ;size of REBARBANDINFO structure
mov     RBBIM_fMask,0B7h        ;flags which members are valid or must filled
                                ;RBBIM_STYLE        = 0001h
                                ;RBBIM_COLORS       = 0002h
                                ;RBBIM_TEXT         = 0004h
                                ;RBBIM_IMAGE        = 0008h
                                ;RBBIM_CHILD        = 0010h
                                ;RBBIM_CHILDSIZE    = 0020h
                                ;RBBIM_SIZE         = 0040h
                                ;RBBIM_BACKGROUND   = 0080h
                                ;RBBIM_ID           = 0100h
                                ;RBBIM_IDEALSIZE    = 0200h
                                ;RBBIM_LPARAM       = 0400h
                                ;RBBIM_HEADERSIZE   = 0800h
mov     RBBIM_fStyle,0C4h       ;flags that specify the band style
                                ;RBBS_BREAK         = 0001h
                                ;RBBS_FIXEDSIZE     = 0002h
                                ;RBBS_CHILDEDGE     = 0004h
                                ;RBBS_HIDDEN        = 0008h
                                ;RBBS_NOVERT        = 0010h
                                ;RBBS_FIXEDBMP      = 0020h
                                ;RBBS_VARIABLEHEIGHT= 0040h
                                ;RBBS_GRIPPERALWAYS = 0080h
mov     RBBIM_clrFore,000000FFh ;band foreground color
mov     RBBIM_clrBack,00000000h ;band background color
mov     RBBIM_lpText,OFFSET sz02;pointer to buffer, display text for the band
mov     RBBIM_cch,0h            ;buffersize RBBIM_lpText in bytes, not used !
mov     RBBIM_iImage,0h         ;index image displayed in band, not used !
mov     RBBIM_hwndChild,ebx     ;handle child window contained in the band
mov     RBBIM_cxMinChild,50h    ;minimum width of the child window, in pixels
mov     RBBIM_cyMinChild,20h    ;minimum height of the child window, in pixels
mov     RBBIM_cx,50h            ;length of the band, in pixels
mov     RBBIM_hbmBack,ecx       ;handle bitmap, the background for this band
mov     RBBIM_wID,0h            ;id for custom draw notification msg., not used !
mov     RBBIM_cyChild,20h       ;initial height of the band, in pixels
mov     RBBIM_cyMaxChild,20h    ;maximum height of the band, in pixels
mov     RBBIM_cyIntegral,1h     ;step value by which band can grow/shrink, not used !
mov     RBBIM_cxIdeal,50h       ;ideal width of the band, in pixels, not used !
mov     RBBIM_lParam,0h         ;32-bit application-defined value, not used !
mov     RBBIM_cxHeader,0h       ;size of the band's header, in pixels, not used !
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    OFFSET RBBIM_cbSize     ;lParam, pointer to REBARBANDINFO structure 
push    -1                      ;wParam, index location where band will inserted
push    1025                    ;uMsg, RB_INSERTBAND (WM_USER=1024)+1
push    hWnd_rebar              ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
ret

My_CleanSystem:
;------------------------------------------------------------------------------
; API "DeleteObject" deletes a logical pen, brush, font, bitmap, region, or
; palette, freeing all system resources associated with the object.
; After the object is deleted, the specified handle is no longer valid.
;------------------------------------------------------------------------------
push    hImg_rebarband0         ;hObject, handle object
call    DeleteObject            ;- API Function -
push    hImg_rebarband1         ;hObject, handle object
call    DeleteObject            ;- API Function -
push    hImg_rebarband2         ;hObject, handle object
call    DeleteObject            ;- API Function -
ret
;******************************************************************************

;==============================================================================
; end Main = end of our program code
;------------------------------------------------------------------------------
end Main                                ;end of our program code, entry point

;==============================================================================
; To create the exe file use this commands with your Microsoft Assembler/Linker
;------------------------------------------------------------------------------
; ml.exe /c /coff td_win32asm_027.asm                           ;asm command
; rc.exe /v rsrc.rc                                             ;rc command
; cvtres.exe /machine:ix86 rsrc.res
; link.exe /subsystem:windows td_win32asm_027.obj rsrc.obj      ;link command
;==============================================================================